<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import CountryFlag from "vue-country-flag";
import axios from "axios";
import { apiErrorHandler, redirectPage } from "@/utils/apiHanlers";
import { api } from "~/common/constaint";
import AdminCollectionModule from "~/store/adminCollection";
import _, { chunk, cloneDeep, uniq } from "lodash";
const slugify = require("slugify");
import { api_key_tiny_editor } from "@/common/constaint";
import draggable from "vuedraggable";
import { image } from "html2canvas/dist/types/css/types/image";

@Component({
  components: {
    draggable,
    MediaPicker: () => import("../../Gallery/MediaPicker/index.vue"),
    Review: () => import("../Review/index.vue"),

    // LoadingComponent: () => import("@/components/Utils/Loading/index.vue"),
  },
})
export default class AdminShopProductComponent extends Vue {
  drag = true;

  api_key_tiny_editor = api_key_tiny_editor;
  adminCollection = getModule(AdminCollectionModule, this.$store);

  dialogMediaPicker = false;
  dialogDeleteProduct = false;
  limitImage = true;
  isSelectMultipleImage = false;

  imageVariant = {
    imageId: "",
    imageUrl: "",
  };
  isImageVariant = false;
  indexImageVariant: any = null;

  // Variant
  listVariantOption: any = [];
  listVariantEditOption: any = [];
  listVariant: any = [];
  listVariantSelected = [];
  listVariantIds: any = [];
  selectedAllVariant = false;
  dialgoEditVariant = false;
  dialogEditOptionVariant = false;
  dialogSortVariant = false;
  optionVariant = "";

  variant = {
    price: 0,
    comparePrice: 0,
    productCost: 0,
    fullfillmentCost: 0,
    sku: "",
    isSellable: true,
  };
  variantName = "";

  imageId = "";

  dragging = false;

  // get loadingFullPage() {
  //   return this.$store.state.adminProduct.loadingFullPage;
  // }
  checkMove(e: any) {}

  openDialogMediaPicker(name: string, variant: any) {
    this.variantName = name;
    this.dialogMediaPicker = true;
    this.isImageVariant = true;
    this.limitImage = true;
    this.imageId = variant?.imageId?._id || variant?.imageId;
  }
  onAddVariant(i: number) {
    this.listVariantOption[i].values.push(
      this.listVariantOption[i].valueOption
    );
    this.listVariantOption[i].valueOption = "";
    // this.onParseListVariant();
  }

  idxOptionVariant = 0;
  idxVariant = 0;
  listVariantEdit: any = [];
  onEditOptionVariant(idxOptionVariant: number, idxVariant: number) {
    this.dialogEditOptionVariant = true;
    this.idxOptionVariant = idxOptionVariant;
    this.idxVariant = idxVariant;
    this.optionVariant =
      this.listVariantOption[this.idxOptionVariant].values[this.idxVariant];
  }

  onRenameOptionVariant() {
    this.listVariantEdit = [...this.product.listVariant];
    this.listVariantOption[this.idxOptionVariant].values[this.idxVariant] =
      this.optionVariant;
    this.onParseListVariantEdit();
    this.isSubmit = true;
    this.dialogEditOptionVariant = false;
    this.optionVariant = "";
  }

  onRemoveVariant(idxOptionVariant: number, idxVariant: number) {
    // if (this.listVariantOption[idxOptionVariant].values.length === 1) {
    //   return this.$pushNotification.error("Unable to delete last variant");
    // }
    this.listVariantOption[idxOptionVariant].values.splice(idxVariant, 1);
    // this.onParseListVariant();
  }

  openDialogSortVariant() {
    this.listVariantEdit = cloneDeep(this.product.listVariant);
    this.listVariantEditOption = cloneDeep(this.listVariantOption);

    this.dialogSortVariant = true;
  }

  async onSortVariant() {
    for (let option of this.listVariantOption) {
      for (let optionEdit of this.listVariantEditOption) {
        if (option.name === optionEdit.name) {
          option.values = optionEdit.values;
        }
      }
    }
    this.onParseListVariantSort();
    this.isSubmit = true;
    await this.onUpdateProduct();
    this.getDetail();
    this.dialogSortVariant = false;
    this.selectedAllVariant = false;
    this.listVariantIds = [];
  }

  onAddOptionVariant() {
    this.listVariantOption.push({
      name: "",
      valueOption: "",
      values: [],
    });
  }
  onRemoveOptionVariant(i: number) {
    // if (this.listVariantOption.length === 1) {
    //   return this.$pushNotification.error(
    //     "Unable to delete last option variant"
    //   );
    // }
    this.listVariantOption.splice(i, 1);
    // this.onParseListVariant();
  }

  isSubmit = false; // check bấm nút submit chưa
  async onSubmitNewVariant() {
    this.listVariantEdit = [...this.product.listVariant];
    this.isSubmit = true;
    // this.onParseListVariantSelect();
    this.onParseListVariant();
  }

  async onUpdateVariantOption() {
    try {
      // if (this.listVariantOption.length === 1) {
      //   this.resultArray = [];
      //   this.listVariant = [];
      //   for (let item of this.listVariantOption[0].values) {
      //     this.listVariant.push({
      //       price: 0,
      //       comparePrice: 0,
      //       productCost: 0,
      //       fullfillmentCost: 0,
      //       sku: "",
      //       imageId: "",
      //       listValue: [item],
      //       name: item,
      //     });
      //   }
      // }
      const listVariantOption = this.listVariantOption.map((item: any) => ({
        name: item.name,
        values: item.values,
      }));

      for (let variant of this.product.listVariant) {
        variant.comparePrice = parseFloat(
          variant.comparePrice.toString().replace(",", ".")
        );
        variant.price = parseFloat(variant.price.toString().replace(",", "."));
        variant.productCost = parseFloat(
          variant.productCost.toString().replace(",", ".")
        );
        variant.fullfillmentCost = parseFloat(
          variant.fullfillmentCost.toString().replace(",", ".")
        );
      }

      this.loading = true;
      const body = {
        productId: this.productId,
        listVariantOption: listVariantOption,
        listVariant: this.product.listVariant,
      };
      await this.$api.product.updateVariantOption(body);
      this.listVariantIds = [];
      this.selectedAllVariant = false;
      this.onHandleVariantSelect("none");
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  loadingId = "";
  async onUpdateVariant() {
    try {
      for (let item of this.product.listVariant) {
        if (!(item.price && item.comparePrice && item.productCost)) {
          {
            this.$pushNotification.error("Please enter all field");
            return false;
          }
        }
      }

      for (let variant of this.product.listVariant) {
        variant.comparePrice = parseFloat(
          variant.comparePrice.toString().replace(",", ".")
        );
        variant.price = parseFloat(variant.price.toString().replace(",", "."));
        variant.productCost = parseFloat(
          variant.productCost.toString().replace(",", ".")
        );
        variant.fullfillmentCost = parseFloat(
          variant.fullfillmentCost.toString().replace(",", ".")
        );
      }

      const listVariant = this.product.listVariant.map((item: any) => ({
        variantId: item._id,
        price: item.price,
        comparePrice: item.comparePrice,
        productCost: item.productCost,
        fullfillmentCost: item.fullfillmentCost,
        imageId: item.imageId,
        sku: item.sku,
        isSellable: item.isSellable,
      }));

      let body = {
        productId: this.productId,
        listVariant,
      };
      // if (variant) {
      // 	this.loadingId = variant._id;
      // 	const {
      // 		comparePrice,
      // 		productCost,
      // 		fullfillmentCost,
      // 		sku,
      // 		imageId,
      // 		price,
      // 	} = variant;
      // 	body = {
      // 		productId: this.productId,
      // 		listVariant: [variant._id],
      // 		comparePrice,
      // 		productCost,
      // 		fullfillmentCost,
      // 		sku,
      // 		imageId,
      // 		price,
      // 	};
      // }
      // else {
      // 	if (!this.listVariantIds.length) {
      // 		return this.$pushNotification.error(
      // 			"Please choose variant"
      // 		);
      // 	}
      // 	for (let id of this.listVariantIds) {
      // 		const findProduct = this.product.listVariant.find(
      // 			(item: any) => item.listValue.join(" / ") === id
      // 		);
      // 		console.log("findProduct :>> ", findProduct);
      // 		if (findProduct) {
      // 			listVariantId.push(findProduct._id);
      // 		}
      // 	}
      // 	console.log("listVariantId :>> ", listVariantId);
      // 	// return;
      // 	const findProductFirst = this.product.listVariant.find(
      // 		(item: any) =>
      // 			item.listValue.join(" / ") === this.listVariantIds[0]
      // 	);
      // 	if (findProductFirst) {
      // 		const {
      // 			comparePrice,
      // 			productCost,
      // 			fullfillmentCost,
      // 			stock,
      // 			sku,
      // 			imageId,
      // 			price,
      // 		} = findProductFirst;
      // 		body = {
      // 			listVariantId,
      // 			comparePrice,
      // 			productCost,
      // 			fullfillmentCost,
      // 			stock,
      // 			sku,
      // 			imageId,
      // 			price,
      // 		};
      // 	}
      // }

      await this.$api.product.updateVariant(body);
      // this.$pushNotification.success("Updated variant successfully");
      // this.getDetail();
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  resultArray: any = [];

  onParseListVariant() {
    let findSku = "";
    if (this.product?.listVariant[0]?.sku) {
      findSku = this.product.listVariant[0].sku;
    }
    let numLength = 1;
    this.listVariantIds = [];
    if (this.listVariantOption.length > 1) {
      for (let item of this.listVariantOption) {
        if (!item.values.length) {
          return this.$pushNotification.error(
            "Please remove option variant empty"
          );
        }
      }
      let arr = this.listVariantOption.map((item: any) =>
        chunk(item.values, 1)
      );
      this.resultArray = [];
      const listVariant = [...this.product.listVariant];
      this.product.listVariant = [];
      for (let i = 0; i < arr.length; i++) {
        let handleArray = arr[i];
        const gop = this.gop2mang(this.resultArray, handleArray);
        this.resultArray = [...gop];
      }
      for (let result of this.resultArray) {
        const variant = result.join(" / ");
        this.product.listVariant.push({
          price: 0,
          comparePrice: 0,
          productCost: 0,
          fullfillmentCost: 0,
          sku: "",
          imageId: "",
          listValue: uniq(result),
          name: variant,
          isSellable: true,
        });
        numLength += 1;
      }
      if (listVariant.length) {
        let findLargestNumber = 0;
        for (let item of listVariant) {
          const skuNumber = parseInt(item.sku.split("-")[1]);
          if (skuNumber > findLargestNumber) {
            findLargestNumber = skuNumber;
          }
        }
        for (let item of this.product.listVariant) {
          const findVariant = listVariant.find(
            (variant: any) => variant.listValue.join(" / ") === item.name
          );
          if (findVariant) {
            item.price = findVariant.price;
            item.comparePrice = findVariant.comparePrice;
            item.productCost = findVariant.productCost;
            item.fullfillmentCost = findVariant.fullfillmentCost;
            item.sku = findVariant.sku;
            item.imageId = findVariant.imageId;
            item.listValue = findVariant.listValue;
            item.name = findVariant.name;
            item.isSellable = findVariant.isSellable;
          } else {
            findLargestNumber += 1;
            const skuReplace = findSku.split("-")[0];
            const sku = skuReplace + "-" + findLargestNumber;
            item.sku = sku;
          }
        }
      }
      this.onFillSku();
      this.product.listVariantOption = this.listVariantOption;
    } else {
      console.log("vào day");
      this.resultArray = [];
      if (this.listVariantOption[0] && this.listVariantOption[0].values) {
        this.product.listVariant = [];
        for (let item of this.listVariantOption[0].values) {
          const findLastSku =
            this.listVariantEdit[this.listVariantEdit.length - 1];
          this.product.listVariant.push({
            price: 0,
            comparePrice: 0,
            productCost: 0,
            fullfillmentCost: 0,
            sku: findSku.split("-")[0] + "-" + numLength,
            imageId: "",
            listValue: [item],
            name: item,
            isSellable: true,
          });
          numLength += 1;
        }
        this.onSetListVariant();
      }
    }
  }

  onParseListVariantEdit() {
    this.listVariantIds = [];
    if (this.listVariantOption.length > 1) {
      for (let item of this.listVariantOption) {
        if (!item.values.length) {
          return this.$pushNotification.error(
            "Please remove option variant empty"
          );
        }
      }
      let arr = this.listVariantOption.map((item: any) =>
        chunk(item.values, 1)
      );
      this.resultArray = [];
      // this.listVariantEdit = [];
      for (let i = 0; i < arr.length; i++) {
        let handleArray = arr[i];
        const gop = this.gop2mang(this.resultArray, handleArray);
        this.resultArray = [...gop];
      }
      for (let result of this.resultArray) {
        const variant = result.join(" / ");
        // const findVariant = this.listVariant.find(
        // 	(item: any) => item.name === variant
        // );
        // if (findVariant) continue;
        this.product.listVariant.forEach((item: any, i: number) => {
          item.price = this.listVariantEdit[i].price;
          item.comparePrice = this.listVariantEdit[i].comparePrice;
          item.productCost = this.listVariantEdit[i].productCost;
          item.fullfillmentCost = this.listVariantEdit[i].fullfillmentCost;
          item.sku = this.listVariantEdit[i].sku;
          item.imageId = this.listVariantEdit[i].imageId;
          item.listValue = this.resultArray[i];
          item.name = this.resultArray[i]?.join(" / ");
          item.isSellable = this.listVariantEdit[i].isSellable;
        });
      }
      this.product.listVariantOption = this.listVariantOption;
    } else {
      this.resultArray = [];
      if (this.listVariantOption[0] && this.listVariantOption[0].values) {
        this.onSetListVariant();
      }
    }
  }

  onParseListVariantSort() {
    this.listVariantIds = [];
    if (this.listVariantOption.length > 1) {
      for (let item of this.listVariantOption) {
        if (!item.values.length) {
          return this.$pushNotification.error(
            "Please remove option variant empty"
          );
        }
      }
      let arr = this.listVariantOption.map((item: any) =>
        chunk(item.values, 1)
      );
      this.resultArray = [];
      // this.listVariantEdit = [];
      for (let i = 0; i < arr.length; i++) {
        let handleArray = arr[i];
        const gop = this.gop2mang(this.resultArray, handleArray);
        this.resultArray = [...gop];
      }
      this.product.listVariant.forEach((item: any, i: number) => {
        item.price = this.listVariantEdit[i].price;
        item.comparePrice = this.listVariantEdit[i].comparePrice;
        item.productCost = this.listVariantEdit[i].productCost;
        item.fullfillmentCost = this.listVariantEdit[i].fullfillmentCost;
        item.sku = this.listVariantEdit[i].sku;
        item.imageId = this.listVariantEdit[i].imageId;
        item.listValue = this.resultArray[i];
        item.name = this.resultArray[i]?.join(" / ");
        item.isSellable = this.listVariantEdit[i].isSellable;
      });
      for (let variant of this.product.listVariant) {
        for (let item of this.listVariantEdit) {
          if (variant.listValue.join(" / ") === item.listValue.join(" / ")) {
            variant.price = item.price;
            variant.comparePrice = item.comparePrice;
            variant.productCost = item.productCost;
            variant.fullfillmentCost = item.fullfillmentCost;
            variant.sku = item.sku;
            variant.imageId = item.imageId;
            variant.listValue = item.listValue;
            variant.name = item.listValue?.join(" / ");
            variant.isSellable = item.isSellable;
          }
        }
      }
      this.product.listVariantOption = this.listVariantOption;
    } else {
      this.resultArray = [];
      if (this.listVariantOption[0] && this.listVariantOption[0].values) {
        this.onSetListVariantSort();
      }
    }
  }

  onSetListVariant() {
    this.listVariantOption[0].values.forEach((item: any, i: number) => {
      if (
        this.listVariantEdit[i] &&
        this.listVariantEdit[i].price &&
        this.product.listVariant[i].name === item
      ) {
        const findVariant = this.listVariantEdit.find(
          (variant: any) => variant.listValue.join(" / ") === item
        );
        if (findVariant) {
          this.product.listVariant[i].price = findVariant.price;
          this.product.listVariant[i].comparePrice = findVariant.comparePrice;
          this.product.listVariant[i].productCost = findVariant.productCost;
          this.product.listVariant[i].fullfillmentCost =
            findVariant.fullfillmentCost;
          this.product.listVariant[i].sku = findVariant.sku;
          this.product.listVariant[i].imageId = findVariant.imageId;
          this.product.listVariant[i].listValue = [...findVariant.listValue];
          this.product.listVariant[i].name = findVariant.listValue.join(" / ");
          this.product.listVariant[i].isSellable = findVariant.isSellable;
        } else {
          this.product.listVariant[i].price = this.listVariantEdit[i].price;
          this.product.listVariant[i].comparePrice =
            this.listVariantEdit[i].comparePrice;
          this.product.listVariant[i].productCost =
            this.listVariantEdit[i].productCost;
          this.product.listVariant[i].fullfillmentCost =
            this.listVariantEdit[i].fullfillmentCost;
          this.product.listVariant[i].sku = this.listVariantEdit[i].sku;
          this.product.listVariant[i].imageId = this.listVariantEdit[i].imageId;
          this.product.listVariant[i].listValue = [item];
          this.product.listVariant[i].name = item;
          this.product.listVariant[i].isSellable =
            this.listVariantEdit[i].isSellable;
        }
      }
    });
  }

  onSetListVariantSort() {
    this.listVariantOption[0].values.forEach((item: any, i: number) => {
      if (this.listVariantEdit[i] && this.listVariantEdit[i].price) {
        const findVariant = this.listVariantEdit.find(
          (variant: any) => variant.listValue.join(" / ") === item
        );
        this.product.listVariant[i].price = findVariant.price;
        this.product.listVariant[i].comparePrice = findVariant.comparePrice;
        this.product.listVariant[i].productCost = findVariant.productCost;
        this.product.listVariant[i].fullfillmentCost =
          findVariant.fullfillmentCost;
        this.product.listVariant[i].sku = findVariant.sku;
        this.product.listVariant[i].imageId = findVariant.imageId;
        this.product.listVariant[i].listValue = findVariant.listValue;
        this.product.listVariant[i].name = findVariant.listValue.join(" / ");
        this.product.listVariant[i].isSellable = findVariant.isSellable;
      }
    });
  }

  onFillSku() {
    // this.product.listVariant.forEach((item: any, i: number) => {
    //   if (this.listVariantEdit[i]) {
    //     this.product.listVariant[i].sku = this.listVariantEdit[i].sku;
    //   }
    // });
  }

  resultArraySelect: any = [];

  onParseListVariantSelect() {
    if (this.listNameSelect.length > 1) {
      let arr = this.listNameSelect.map((item: any) => chunk(item.values, 1));
      this.resultArraySelect = [];
      for (let i = 0; i < arr.length; i++) {
        let handleArray = arr[i];
        const gop = this.gop2mang(this.resultArraySelect, handleArray);
        this.resultArraySelect = [...gop];
      }
    } else {
      this.resultArraySelect = [];
      if (
        this.listNameSelect[0] &&
        this.listNameSelect[0].values.length === 1
      ) {
        this.resultArraySelect = [this.listNameSelect[0].values];
      } else if (
        this.listNameSelect[0] &&
        this.listNameSelect[0].values.length > 1
      ) {
        this.resultArraySelect = this.listNameSelect[0].values.map(
          (item: any) => [item]
        );
      } else {
        this.resultArraySelect = [];
      }
    }
  }

  gop2mang(array1: any, array2: any) {
    let arrColorSize = [];
    if (!array1.length) return array2;
    for (let color of array1) {
      for (let size of array2) {
        const variant = color;
        const variantTwo = size;
        arrColorSize.push([...variant, ...variantTwo]);
      }
    }
    return arrColorSize;
  }
  nameSelect: string[] = [];
  listNameSelect: any = [];
  onHandleVariantSelect(type: string) {
    if (type === "all") {
      this.listVariantIds = this.product.listVariant.map((item: any) =>
        item.listValue.join(" / ")
      );
    } else if (type === "none") {
      this.listVariantIds = [];
      this.nameSelect = [];
    }
  }

  onHandleVariantSelected(item: any) {
    this.listVariantIds = [];
    this.listNameSelect = [];
    const findIdxName = this.nameSelect.findIndex((elem) => elem === item);
    if (findIdxName === -1) {
      this.nameSelect.push(item);
    } else {
      this.nameSelect.splice(findIdxName, 1);
    }
    for (let i = 0; i < this.listVariantOption.length; i++) {
      const list = this.listVariantOption[i].values.filter((value: any) =>
        this.nameSelect.includes(value)
      );
      this.listNameSelect.push({ i, values: list });
    }
    this.listNameSelect = this.listNameSelect.filter(
      (item: any) => item.values.length
    );
    this.onParseListVariantSelect();
    let listVariant = [];
    for (let elem of this.product.listVariant) {
      const listName = elem.listValue;
      listVariant.push(listName);
    }
    let listFoundFinal: any = [];
    for (const listSelectFind of this.resultArraySelect) {
      const listFound = listVariant.filter((variant) => {
        return listSelectFind.every((element: any) =>
          variant.includes(element)
        );
      });
      listFoundFinal = [...listFoundFinal, ...listFound];
    }
    for (let item of listFoundFinal) {
      this.listVariantIds.push(item.join(" / "));
    }
  }

  selectActive(item: string) {
    const findItem = this.nameSelect.find((elem) => elem === item);
    if (findItem) return true;
    return false;
  }
  openDialogEditVariant() {
    this.dialgoEditVariant = true;
    if (this.listVariantIds.length) {
      const findVariant = this.product.listVariant.find(
        (item: any) => item.listValue.join(" / ") === this.listVariantIds[0]
      );
      if (findVariant) {
        const {
          price,
          comparePrice,
          productCost,
          fullfillmentCost,
          sku,
          isSellable,
        } = findVariant;
        this.listVariant = {
          price,
          comparePrice,
          productCost,
          fullfillmentCost,
          sku,
          isSellable,
        };
      }
    }
  }
  onEditVariant() {
    this.listVariantIds.forEach((id: any) => {
      this.product.listVariant.forEach((variant: any) => {
        if (id === variant.listValue.join(" / ")) {
          variant.isSellable = this.variant.isSellable;
          if (this.variant.price) {
            variant.price = this.variant.price;
          }
          if (this.variant.comparePrice) {
            variant.comparePrice = this.variant.comparePrice;
          }
          if (this.variant.productCost) {
            variant.productCost = this.variant.productCost;
          }
          if (this.variant.fullfillmentCost) {
            variant.fullfillmentCost = this.variant.fullfillmentCost;
          }
        }
      });
    });
    this.dialgoEditVariant = false;
    this.variant = {
      price: 0,
      comparePrice: 0,
      productCost: 0,
      fullfillmentCost: 0,
      sku: "",
      isSellable: true,
    };
  }
  // End variant

  resetContent = false;

  config = {
    page: 1,
    limit: 25,
    search: "",
  };
  totalPage: number = 0;

  configProduct = {
    page: 1,
    limit: 25,
    search: "",
    filter: {},
  };
  totalPageProduct: number = 0;

  loadingTable = false;
  loadingTableProduct = false;
  selectedAll = false;
  dialogAddRelatedProduct = false;
  filterCollection = "All";
  listRelatedProduct = [];
  listRelatedProductIds = [];
  listAllProduct = [];
  listProduct: any = [];
  listProductIds = [];
  listCollection: any = [];
  listVariantProduct: any = [];
  listLanguage = [
    { name: "English", value: "EN" },
    { name: "Germany", value: "DE" },
    { name: "Spain", value: "ES" },
    { name: "Italy", value: "IT" },
  ];
  product: any = {
    categoryId: "", // Không bắt buộc
    name: "",
    slug: "",
    language: "EN",
    productStatus: false, // Không bắt buộc
    variant: [],
    description: "",
    relatedProduct: [], // Khoong
    coverId: "",
    listImageId: [], // Khoong
  };
  imageRender = "";
  collectionStatus = true;
  loading = false;
  loadingUpdate = false;
  loadingCreate = null;

  variantIdx = "";
  tiptapWord = "";
  imageAdd = "";
  listCoverIdComponent: any = [];
  productId = "";
  productSlug = "";
  beforeDestroy() {
    this.product = {
      categoryId: "", // Không bắt buộc
      name: "",
      slug: "",
      language: "EN",
      productStatus: false, // Không bắt buộc
      variant: [],
      description: "",
      relatedProduct: [], // Khoong
      coverId: "",
      listImageId: [], // Khoong
    };
    this.listVariantProduct = [];
    this.resetContent = true;
    this.$store.commit("adminGallery/setListCoverId", []);
    this.$store.commit("adminCollection/setCoverId", {
      coverId: "",
      imageUrl: "",
    });
  }

  async created() {
    // setTimeout(() => {
    // 	const a = document.querySelector(
    // 		"button[title='Insert/edit image']"
    // 	);
    // 	a?.addEventListener("click", () => {
    // 		this.tiptapWord = "tiptapWord";
    // 		this.dialogMediaPicker = true;
    // 	});
    // }, 1000);
  }
  get imageUrl() {
    return this.$store.state.adminCollection.imageUrl;
  }
  // setImageEditor(value: string) {
  // 	if (value) {
  // 		//@ts-ignore
  // 		tinyMCE.execCommand(
  // 			"mceInsertContent",
  // 			false,
  // 			'<img alt="hinh_anh" height="42" width="42" src="' +
  // 				`${value}` +
  // 				'"/>'
  // 		);
  // 	}
  // }
  async mounted() {
    this.$store.commit("adminProduct/setLoadingFullPage", true);
    const { slug } = this.$route.params;
    this.productSlug = slug || "";
    const prom = [
      // this.onGetListAllProduct(),
      // this.onGetListCollection(),
      this.getDetail(),
      // this.onGetListProduct(),
    ];
    await Promise.all(prom);
    this.$store.commit("adminProduct/setLoadingFullPage", false);
    // this.onGetListVariantProduct()
  }

  async onGetListAllProduct() {
    try {
      const response = await this.$api.product.getListAdmin(this.config);
      if (response?.data?.data) {
        this.listAllProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  async onGetListProduct() {
    try {
      if (this.filterCollection !== "All") {
        //@ts-ignore
        this.configProduct.filter["categoryId"] = this.filterCollection;
      } else {
        //@ts-ignore
        delete this.configProduct.filter["categoryId"];
      }
      this.loadingTableProduct = true;
      const response = await this.$api.product.getListAdmin(this.configProduct);
      const { page, total, totalInList, data } = response.data;
      this.totalPageProduct = Math.ceil(total / this.configProduct.limit);
      if (response?.data?.data) {
        this.listProduct = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingTableProduct = false;
    }
  }

  async onGetListCollection() {
    try {
      const response = await this.$store.dispatch(
        "adminCollection/onGetListCollection",
        {
          ctx: this,
        }
      );
      if (response?.data?.data) {
        this.listCollection = response.data.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  async getDetail() {
    try {
      const response = await this.$api.product.getDetailAdmin(this.productSlug);
      if (response?.data) {
        this.productId = response.data._id;
        this.product = response.data;
        this.listVariantProduct = this.product.listVariant;
        this.listCoverIdComponent = this.product.listImageId.filter(
          (img: any) => {
            return {
              imageId: img._id,
              imageUrl: img.imageUrl,
            };
          }
        );
        // this.$store.commit("adminCollection/setCoverId", {
        // 	coverId: this.product.coverId._id,
        // 	imageUrl: this.product.coverId.imageUrl,
        // });
        if (this.product && this.product.listVariantOptionId.length) {
          const listVariantOptionId = cloneDeep(
            this.product.listVariantOptionId
          );
          listVariantOptionId.forEach((item: any) => (item.valueOption = ""));
          this.listVariantOption = listVariantOptionId;
        }
        setTimeout(() => {
          this.product.slug = this.productSlug;
        }, 300);
      }
    } catch (error) {
      console.log("error :>> ", error);
      apiErrorHandler(error, this);
    }
  }

  // async onGetListVariantProduct(){
  // 	try {
  // 		const response = await this.$api.listVariant.list()
  // 	} catch (error) {

  // 	}
  // }

  onSelectImage(isImageVariant?: any) {
    this.limitImage = true;
    this.tiptapWord = "";
    this.dialogMediaPicker = true;
    if (isImageVariant === "isImageVariant") {
      this.isImageVariant = true;
      // this.indexImageVariant = idx;
    }
  }

  onSelectMultipleImage() {
    this.limitImage = false;
    this.isSelectMultipleImage = true;
    this.dialogMediaPicker = true;
  }

  removeImage() {
    // this.$store.commit("adminCollection/setCoverId", {
    // 	coverId: "",
    // 	imageUrl: "",
    // });
    this.listCoverIdComponent.splice(0, 1);
  }

  removeImageChild(i: number) {
    this.listCoverIdComponent.splice(i + 1, 1);
  }

  async onUpdateProduct() {
    try {
      const coverId = this.$store.state.adminCollection.coverId;
      if (coverId) {
        this.product.coverId = coverId;
      }
      if (
        !(
          this.product.productName &&
          this.product.slug &&
          this.product.description
        )
      ) {
        return this.$pushNotification.error(
          "Please enter your name, link and description"
        );
      }

      for (let variant of this.product.listVariant) {
        if (
          !(
            variant.price &&
            variant.comparePrice &&
            variant.productCost &&
            variant.sku
          )
        ) {
          return this.$pushNotification.error(
            "Please enter cost price, variant compare price, variant product cost & sku"
          );
        } else if (
          variant.price < 1 &&
          variant.comparePrice < 1 &&
          variant.productCost < 1
        ) {
          return this.$pushNotification.error(
            "Price, variant compare price, variant product cost cannot be less than 1"
          );
        } else if (!variant.imageId) {
          return this.$pushNotification.error("Please choose variant image");
        }

        const fieldNameToCheck = "sku";
        const duplicateValues = this.$utils.findDuplicates(
          this.product.listVariant,
          fieldNameToCheck
        );
        if (duplicateValues.length > 0) {
          return this.$pushNotification.error(
            `Duplicate values found in the field ${fieldNameToCheck}: ${duplicateValues}`
          );
        }
      }

      // if (!this.product.coverId) {
      // 	return this.$pushNotification.error(
      // 		"Please select product image thumbnail"
      // 	);
      // }
      if (!this.product.listVariant.length) {
        return this.$pushNotification.error("Variant cannot be less than 1");
      }
      const listCoverId = this.listCoverIdComponent;
      if (!listCoverId.length) {
        return this.$pushNotification.error("Please select product image");
      }

      this.product.listImageId = listCoverId.map((item: any) => item._id);

      this.loadingUpdate = true;
      let {
        salePrice,
        categoryId,
        productName,
        slug,
        productStatus,
        variant,
        description,
        relatedProduct,
        listImageId,
      } = this.product;
      if (this.listRelatedProduct.length) {
        relatedProduct = this.listRelatedProduct.map(
          (product: any) => product._id
        );
      }
      const payload = {
        categoryId,
        productName,
        slug,
        productStatus,
        variant,
        description,
        relatedProduct,
        listImageId,
        salePrice,
        coverId: this.$store.state.adminCollection.coverId,
      };
      if (this.isSubmit) {
        await this.onUpdateVariantOption();
      } else {
        await this.onUpdateVariant();
        // const status = await this.onUpdateVariant();
        // if (!status) return;
      }
      await this.$api.product.edit(this.productId, payload);
      this.$pushNotification.success("Updated product successfully");
      this.isSubmit = false;
      // this.productSlug = slug;
      // this.$router.push(`/admin/products/edit/${this.productSlug}`);
      // this.getDetail();
      this.listVariantIds = [];
      this.selectedAllVariant = false;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loadingUpdate = false;
    }
  }

  addVariantProduct() {
    this.listVariantProduct.push({
      name: "",
      originPrice: 0,
      price: 0,
      imageId: "",
      imageUrl: "",
      size: "",
      color: "",
    });
  }

  deleteVariant(variant: any, idx: number) {
    this.listVariantProduct.splice(idx, 1);
  }

  async onDeleteProduct() {
    try {
      this.loading = true;
      await this.$api.product.delete(this.productId);
      this.$pushNotification.success("Deleted product successfully");
      this.$router.push("/admin/shop/product");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onAddRelatedProduct() {
    for (let id of this.listProductIds) {
      const findProduct = this.listAllProduct.find(
        (product: any) => product._id === id
      );
      if (findProduct) {
        this.listRelatedProduct.push(findProduct);
      }
    }
    this.listRelatedProduct = _.unionBy(this.listRelatedProduct, "_id");
    this.listProductIds = [];
    this.dialogAddRelatedProduct = false;
  }

  onDeleteRelatedProduct() {
    for (let id of this.listRelatedProductIds) {
      const findIdx = this.listRelatedProduct.findIndex(
        (product: any) => product._id === id
      );
      if (findIdx !== -1) {
        this.listRelatedProduct.splice(findIdx, 1);
      }
    }
    this.listRelatedProductIds = [];
    this.selectedAll = false;
  }

  generateSlug(tilte: string) {
    const options = {
      replacement: "-",
      remove: undefined,
      lower: true,
      strict: false,
      locale: "en",
      trim: true,
    };
    let slug = slugify(tilte, options);
    slug = slug.replaceAll(`'`, "");
    return slug;
  }
  convertMultipleImage(cover: any) {
    if (cover.imageUrl) {
      return `${api}/${cover.imageUrl}`;
    }
    return "";
  }
  convertImageVariant(variant: any) {
    if (variant?.imageId?.imageUrl) {
      return `${api}/${variant.imageId.imageUrl}`;
    } else if (variant?.imageUrl) {
      return `${api}/${variant.imageUrl}`;
    }
    return "";
  }
  covertImage(variant: any) {
    if (variant) {
      return `${api}/${variant}`;
    }
    return "";
  }
  // totalStockProduct(product: any) {
  // 	let num = 0;
  // 	if (product) {
  // 		for (let sanpham of product.listVariant) {
  // 			if (sanpham && sanpham.stock) {
  // 				num += sanpham.stock;
  // 			}
  // 		}
  // 	}
  // 	return num || product.stock;
  // }
  calcPrice(product: any) {
    let price = 0;
    if (product && product.listVariant && product.listVariant.length) {
      price = product.listVariant[0].price;
      // for (let variant of product.listVariant) {
      // 	price += variant.price;
      // }
    } else {
      return product.price;
    }
    return Math.round(price * 100) / 100;
  }
  convertImg(product: any) {
    if (product?.coverId?.imageUrl) {
      return `${api}/${product.coverId.imageUrl}`;
    }
    return "";
  }
  get convertImage() {
    const imageUrl = this.listCoverIdComponent[0]?.imageUrl || "";
    if (imageUrl) {
      return `${api}/${imageUrl}`;
    }
    return "";
  }

  get listCoverId() {
    const listCoverId = cloneDeep(this.$store.state.adminGallery.listCoverId);
    return listCoverId && listCoverId;
  }

  set listCoverId(value: any) {
    this.$store.commit("adminGallery/setListCoverId", value);
  }

  get initEditor() {
    return {
      height: 1000,
      image_title: true,
      automatic_uploads: true,
      //@ts-ignore
      file_picker_callback: function (cb, value, meta) {
        var input = document.createElement("input");
        input.setAttribute("type", "file");
        input.setAttribute("accept", "image/*");
        input.onchange = function () {
          //@ts-ignore
          var file = this.files[0];

          var reader = new FileReader();
          reader.onload = function () {
            var id = "blobid" + new Date().getTime();
            var blobCache =
              //@ts-ignore
              tinymce.activeEditor.editorUpload.blobCache;
            //@ts-ignore
            var base64 = reader.result.split(",")[1];
            var blobInfo = blobCache.create(id, file, base64);
            blobCache.add(blobInfo);
            cb(blobInfo.blobUri(), { title: file.name });
          };
          reader.readAsDataURL(file);
        };

        input.click();
      },
      file_picker_types: "image",
      plugins: ["lists link image code help wordcount"],
      toolbar:
        "undo redo | formatselect | bold italic | forecolor alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | image link media template codesample inserttable | charmap emoticons hr | pagebreak nonbreaking anchor toc | insertdatetime | help",
    };
  }
  @Watch("selectedAll")
  async onSelectAllChanged(value: string, oldValue: string) {
    if (value) {
      const listRelatedProductIds = [...this.listRelatedProductIds];
      //@ts-ignore
      const selectedCurrentProduct = this.listRelatedProduct
        //@ts-ignore
        .map((product) => product._id)
        //@ts-ignore
        .filter((id) => !listRelatedProductIds.includes(id));
      //@ts-ignore
      this.listRelatedProductIds = [
        ...listRelatedProductIds,
        ...selectedCurrentProduct,
      ];
    } else {
      //@ts-ignore
      const selectedCurrentProduct = this.listRelatedProduct
        //@ts-ignore
        .map((product) => product._id);
      this.listRelatedProductIds = this.listRelatedProductIds.filter(
        (c) => !selectedCurrentProduct.includes(c)
      );
    }
  }

  @Watch("selectedAllVariant")
  async onSelectAllVariantChanged(value: string, oldValue: string) {
    if (value) {
      const listVariantIds = [...this.listVariantIds];
      //@ts-ignore
      const selectedCurrentVariant = this.product.listVariant
        //@ts-ignore
        .map((item) => item.listValue.join(" / "))
        .filter(
          (name: any) =>
            //@ts-ignore
            !listVariantIds.includes(name)
        );
      //@ts-ignore
      this.listVariantIds = [...listVariantIds, ...selectedCurrentVariant];
    } else {
      //@ts-ignore
      const selectedCurrentVariant = this.product.listVariant
        //@ts-ignore
        .map((item) => item.listValue.join(" / "));
      this.listVariantIds = this.listVariantIds.filter(
        (c: any) => !selectedCurrentVariant.includes(c)
      );
    }
  }

  removeAccents(str: string) {
    return str
      .normalize("NFD")
      .replace(/[\u0300-\u036f]/g, "")
      .replace(/đ/g, "d")
      .replace(/Đ/g, "D");
  }

  async onCopySlug(slug: string) {
    try {
      const link = this.linkProduct(slug);
      //@ts-ignore
      await this.$copyText(link);
      this.$pushNotification.success("Copy link successfully");
    } catch (error) {
      this.$pushNotification.success("Copy link failed");
    }
  }

  linkProduct(slug: string) {
    //@ts-ignore
    let arrLink: any = [];
    if (window.location.origin.includes("dash")) {
      arrLink = window.location.origin.split("dash.");
    } else {
      arrLink = window.location.origin.split("admin.");
    }
    const link = arrLink.join("");
    return `${link}/products/${slug}`;
  }

  @Watch("product.productName")
  changedName(val: string) {
    const parseSlug = this.removeAccents(val);
    const slug = this.generateSlug(parseSlug);
    this.product.slug = slug;
  }

  @Watch("isImageVariant")
  changedIsImageVariant(value: boolean) {
    if (!value) {
      if (this.variantName) {
        const listVariant = cloneDeep(this.product.listVariant);
        listVariant.forEach((item: any) => {
          if (this.variantName === item.listValue.join(" / ")) {
            item.imageId = this.imageVariant.imageId;
            item.imageUrl = this.imageVariant.imageUrl;
          }
        });
        this.$nextTick(() => {
          this.product.listVariant = listVariant;
        });
        this.variantName = "";
      } else {
        const listVariant = cloneDeep(this.product.listVariant);
        this.listVariantIds.forEach((id: any) => {
          listVariant.forEach((item: any) => {
            if (id === item.listValue.join(" / ")) {
              item.imageId = this.imageVariant.imageId;
              item.imageUrl = this.imageVariant.imageUrl;
            }
          });
        });
        this.$nextTick(() => {
          this.product.listVariant = listVariant;
        });
      }
      this.imageVariant = {
        imageId: "",
        imageUrl: "",
      };
    }
  }

  @Watch("dialogAddRelatedProduct")
  changedDialogAddRelatedProduct(val: Boolean) {
    if (val) {
      this.onGetListProduct();
      this.listCollection.unshift({ name: "All", value: "" });
    } else {
      this.listCollection.shift();
    }
  }

  @Watch("configProduct.search")
  changedSearchProduct(val: string) {
    if (!val) {
      this.onGetListProduct();
    }
  }
  @Watch("configProduct.page")
  changedPageProduct(val: string) {
    if (!val) {
      this.onGetListProduct();
    }
  }

  @Watch("filterCollection")
  changedFilterCollection() {
    this.onGetListProduct();
  }

  @Watch("imageAdd")
  changeImageAdd(value: string) {
    // this.setImageEditor(value);
  }

  @Watch("listCoverId")
  changedDialogMediaPicker(value: any) {
    if (value.length) {
      this.listCoverIdComponent = [
        ...this.listCoverIdComponent,
        ...this.listCoverId,
      ];
    }
  }
}
</script>

<style>
.thumbnails-image-child {
  border: 1px dashed #0091ea;
  border-radius: 8px;
  width: 60px;
  height: 60px;
}

.thumbnails-image {
  border: 1px dashed #0091ea;
  border-radius: 8px;
  width: 216px;
  height: 216px;
}

.thumbnails-image-selected .button-remove-image {
  position: absolute;
  top: 6px;
  right: 6px;
}

.thumbnails-image-child-selected .button-remove-image {
  position: absolute;
  top: 0px;
  right: 0px;
}

.thumbnails-image-selected {
  width: 216px;
  height: 216px;
}

.height-radio {
  height: 200px;
  overflow-y: scroll;
}

.ProseMirror {
  padding: 12px 0px 28px 0px !important;
}

.tox-mbtn:nth-child(4) {
  display: none !important;
}

/* .tox-dialog,
.tox-dialog-wrap {
	display: none !important;
} */

.input-search-home .mdi-content-copy {
  background-color: #076ce3;
  padding: 8px;
  position: relative;
  right: -4px;
  border-radius: 4px;
  color: #ffffff !important;
  font-size: 16px;
  cursor: pointer;
}

.border-variant {
  border: 1px solid #c3c3c3;
}

.isActive {
  background: #0ab54e;
  color: #ffffff;
}
</style>
